﻿// See https://aka.ms/new-console-template for more information
using Turing;

Console.WriteLine("(c) Maszyna Turinga 2023");

try
{
    Kod kod = Kod.Wczytaj("program.txt");
    Console.WriteLine("Liczba linii: " + kod.LiczbaLinii);

    Stan stan = Stan.Wczytaj("stan.txt");
    Console.WriteLine("Stan: " + stan);

    //TODO: do testów
    //Czwórka pasującaCzwórka = kod.ZnajdźPasującąCzwórkę(stan.StanGłowicy, stan.StanKomórkiPodGłowicą);
    //Console.WriteLine(pasującaCzwórka);

    Procesor procesor = new Procesor(stan, kod);
    bool b = procesor.WykonajKrok();
    Console.WriteLine("Czy koniec programu: " + !b);
    Console.WriteLine("Stan: " + stan);
}
catch(Exception exc)
{
    ConsoleColor kolorOryginalny = Console.ForegroundColor;
    Console.ForegroundColor = ConsoleColor.Red;
    Console.Error.WriteLine("Błąd: " + exc.Message);
    Console.ForegroundColor = kolorOryginalny;
}

//TODO: (W domu) z kodu tutaj zrobić testy


Console.WriteLine("OK.");