﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Turing
{
    public class Procesor
    {
        private Stan stan;
        private Kod kod;

        public Procesor(Stan stan, Kod kod) 
        {
            this.stan = stan;
            this.kod = kod;
        }

        public bool WykonajKrok()
        {
            Czwórka? pasującaCzwórka = kod.ZnajdźPasującąCzwórkę(stan.StanGłowicy, stan.StanKomórkiPodGłowicą);
            if (pasującaCzwórka == null) return false;
            //TODO: sprawdzać, czy nie ma zapętlenia z jakimś limitem
            switch(pasującaCzwórka.NowyStanKomórki)
            {
                case 'L':
                    stan.PrzesuńGłowicęWLewo();
                    break;
                case 'R':
                    stan.PrzesuńGłowicęWPrawo();
                    break;
                default:
                    stan.ZmieńStanKomórkiPodGłowicą(pasującaCzwórka.NowyStanKomórki);
                    break;
            }
            return true;
        }

        public void WykonajProgram()
        {
            //TODO: zdarzenia
        }
    }
}
